<?php

/**
 * Die ShopwareAG wünscht überall Kommentar, dies ist ein Kommentar.
 * Class Shopware_Controllers_Backend_AduInkasso
 */
class Shopware_Controllers_Backend_AduInkasso extends Shopware_Controllers_Backend_ExtJs
{

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     *
     * @return Shopware_Components_AduInkassoApi
     */
    protected function getAduInkassoApi()
    {
        return Shopware()->AduInkassoApi();
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     */
    public function loadAction()
    {
        parent::loadAction();

        $connection = $this->getAduInkassoApi()->testConnection() ? 'open' : 'closed';

        $this->view->assign('aduinkasso_connection', $connection);
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     * @return array
     */
    private function getAkteDatenArray()
    {
        return array(
            'datumHauptforderung',
            'uebernahmeDatum',
            'abschlussDatum',
            'exportDatum',
            'letzteAenderung',
            'geburtstag',
            'evDatum',
            'haftbefehlDatum',
            'insolvenzDatum'
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     * @param $id
     * @return string
     */
    private function getEinstellungsStringById($id)
    {
        $einstellungen = $this->getEinstellungsartenArray();

        foreach ($einstellungen as $einst) {
            if ($einst['einstellung_ID'] == $id) {
                return $einst['bezeichnung'];
            }
        }

        return 'Einstellungsgrund unbekannt';

    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     */
    public function getAktenAction()
    {

        //orderby options: 'letzteAenderung', 'aktenzeichen', 'name', 'betrag', 'stadium', 'glaeubigerAktenzeichen'

//        $offset = $this->Request()->getParam('start', 0);
        $aktenProSeite = $this->Request()->getParam('limit', 20);
//        $filter = $this->Request()->getParam('filter', array());

        $seite = $this->Request()->getParam('page', 1);
        $sort = $this->Request()->getParam('sort', array());
        $filter = $this->Request()->getParam('filter', array());

        $sortField = 'name';
        if (isset($sort[0]['property'])) {
            $sortField = $sort[0]['property'];
        }

        $sortDir = 'asc';
        if (isset($sort[0]['direction'])) {
            $sortDir = strtolower($sort[0]['direction']);
        }

        $search = '';
        if (isset($filter[0]['value'])) {
            $search = $filter[0]['value'];
        }

        $aktenReturn = $this->getAkten($seite, $aktenProSeite, $sortField, $sortDir, $search);

        $total = $aktenReturn['anzahl'];
        $akten = $aktenReturn['akten'];

        $daten = $this->getAkteDatenArray();

        foreach ($akten as &$akte) {

            $akte['einstellung_eingestellt'] = false;
            $akte['einstellung_grund'] = '';
            $akte['einstellung_datum'] = '';
            if (is_array($akte['einstellung'])) {
                $akte['einstellung_eingestellt'] = true;
                $akte['einstellung_grund'] = $this->getEinstellungsStringById($akte['einstellung']['einstellung_ID']);
                $akte['einstellung_datum'] = new DateTime($akte['einstellung']['datum']);
                $akte['einstellung_ind'] = $akte['einstellung'];
            }

            // PSEUDO STATUS
            if ($akte['einstellung_eingestellt']) {
                $akte['stadium'] = 'eingestellt';
            }

            $akte['gutschrift_stornierbar'] = in_array($akte['stadium'], array('unbekannt', 'ok'));
            $akte['zusatzkosten_stornierbar'] = in_array($akte['stadium'], array('unbekannt', 'ok'));
            $akte['akte_bearbeitbar'] = in_array($akte['stadium'], array('unbekannt', 'ok'));
            $akte['akte_einstellbar'] = in_array($akte['stadium'], array('unbekannt', 'ok'));
            $akte['akte_loeschbar'] = in_array($akte['stadium'], array('unbekannt'));

            // Staat
            $akte['staat'] = $akte['staat_iso'];
            unset($akte['staat_iso']);

            foreach ($daten as $datum) {
                if (strpos($akte[$datum], '0000-00-00') === 0 || $akte[$datum] == '') {
                    $akte[$datum] = '';
                } else {
                    $akte[$datum] = new DateTime($akte[$datum]);
                }
            }

            $akte['lv_datum'] = '';
            $akte['lv_beschreibung'] = '';
            if (is_array($akte['letzterVorgang'])) {
                $akte['lv_datum'] = new DateTime($akte['letzterVorgang']['datum']);
                $akte['lv_beschreibung'] = $akte['letzterVorgang']['beschreibung'];
            }

            $akte['lz_datum'] = '';
            if (is_array($akte['letzteZahlung'])) {
                $akte['lz_datum'] = new DateTime($akte['letzteZahlung']['datum']);

            }

            unset($akte['letzterVorgang'], $akte['letzteZahlung'], $akte['einstellung']);
        }

        $this->view->assign(
            array(
                'success' => true,
                'data' => $akten,
                'total' => $total
            )
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     * @param array $names
     * @return array
     */
    private function getRequestArray(Array$names)
    {
        $return = array();
        foreach ($names as $name) {
            $return[$name] = $this->Request()->getParam($name);
        }

        return $return;
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     */
    public function saveEinstellungAction()
    {
        $data = $this->getRequestArray(
            array(
                'einstellung_ID',
                'glaeubigerAktenzeichen',
                'bemerkung',
                'insolvenaz',
                'sterbedatum'
            )
        );

        $sterbedatum = $data['sterbedatum'];
        if (!empty($sterbedatum)) {
            $data['sterbedatum'] = date('d.m.Y', strtotime($sterbedatum));
        }

        $return = $this->getAduInkassoApi()->callClient('saveEinstellung',array(serialize($data)));

        $this->View()->assign(
            array(
                'success' => true,
                'message' => $return
            )
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     */
    public function saveAkteAction()
    {
        // Id auslesen
//        $id = (int)$this->Request()->getParam('id');

        $data = $this->Request()->getParams();

        $saveData = array();
        $saveData['glaeubigerAktenzeichen'] = array(
            'old' => $this->Request()->getParam('glaeubigerAktenzeichen'),
            'new' => $this->Request()->getParam('glaeubigerAktenzeichen'),
        );
        $saveData['schuldner'] = $this->getRequestArray(
            array(
                'staat',
                'name',
                'vorname',
                'anrede',
                'firma',
                'rechtsform_ID',
                'zuHaenden',
                'strasse',
                'kommentar',
                'plz',
                'ort',
                'geburtstag',
                'telefon',
                'fax',
                'email',
                'arbeitgeber',
                'ehepartner',
                'vertreter',
                'evDatum',
                'haftbefehlDatum',
                'insolvenzDatum',
                'insolvenzAZ',
                'bank',
                'blz',
                'iban',
                'bic',
                'kto',
                'inhaber',
//                'ip'
            )
        );

        foreach ($this->getAkteDatenArray() as $datum) {
            if (isset($saveData['schuldner'][$datum])) {
                $date = $saveData['schuldner'][$datum];
                if (!empty($date)) {
                    $date = strtotime($date);
                    $date = date('c', $date);
                } else {
                    $date = '';
                }
                $saveData['schuldner'][$datum] = $date;
            }
        }

        $saveData['forderungen'] = array();

        $return = $this->getAduInkassoApi()->callClient('saveSchuldner',array(serialize($saveData)));

        $this->View()->assign(
            array(
                'success' => true,
                'message' => $return,
                'saveData' => $saveData,
                'data' => $data
            )
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     */
    public function getNewScoreAction()
    {
        $cid = $this->Request()->getParam('cid');

        /** @var \Shopware\Models\Customer\Customer $cust */
        $cust = Shopware()->Models()->find('Shopware\Models\Customer\Customer', $cid);

        /** @var Shopware_Components_AduInkassoApi $api */
        $api = $this->getAduInkassoApi();
        $ok = $api->createNewScore($cust);

        if ($ok) {
            $return = 'Score wurde erfolgreich abgefragt.';
        } else {
            $return = 'Score konnte nich abgefragt werden.';
        }

        $this->View()->assign(
            array(
                'success' => true,
                'message' => $return
            )
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     * @return \Shopware\CustomModels\AduInkasso\Repository
     */
    private function getBonitaetsdatensatzRep()
    {
        return Shopware()->Models()->getRepository('Shopware\CustomModels\AduInkasso\Bonitaetdatensatz');
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     */
    public function getScoreListAction()
    {
        $cid = $this->Request()->getParam('cid');

        $rep = Shopware()->Models()->getRepository('Shopware\CustomModels\AduInkasso\Bonitaetdatensatz');

        /** @var \Shopware\CustomModels\AduInkasso\Bonitaetdatensatz[] $all */
        $all = $rep->findBy(array('customerId' => $cid), array('abfrage_datum' => 'desc'));


        $scores = array();

        foreach ($all as $single) {
            $scores[] = array(
                'score' => $single->getScore(),
                'datum' => $single->getAbfrageDatum(),
                'zusatzinformationen' => $single->getZusatzinformationen()
            );
        }

        $this->view->assign(
            array(
                'success' => true,
                'data' => $scores,
                'total' => count($scores)
            )
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     */
    public function saveGutschriftAction()
    {

        $data = array();

        $data['glaeubigerAktenzeichen'] = $this->Request()->getParam('glaeubigerAktenzeichen');
        $data['gutschrift'] = $this->getRequestArray(
            array(
                'gutschrift_ID',
                'belegnummer',
                'gutschriftnr',
                'betrag',
                'datum'
            )
        );

        $data['gutschrift']['datum'] = date('c', strtotime($data['gutschrift']['datum']));

        $return = $this->getAduInkassoApi()->callClient('saveGutschrift',array(serialize($data)));

        if ($return === "1") {
            $return = 'Gutschrift wurde erfolgreich angelegt.';
        }

        $this->View()->assign(
            array(
                'success' => true,
                'message' => $return
            )
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     * @param $adu
     * @return string
     */
    private function getAduInkassoSalutionFromShopwareSalutation($adu)
    {
        switch ($adu) {
            case 'ms':
                return 'Frau';
                break;
            case 'mr':
                return 'Herr';
                break;
            default:
                return 'Sonstiges';
                break;
        }
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     */
    public function transferOrdersAction()
    {
        $ids = (array)$this->Request()->getParam('orders');

        $zahlungsstatusbeschreibung = Shopware()->Plugins()->Backend()->AduinkAduInkasso()->getZahlungsstatusBeschreibung();

        // zahlungsstatus finden
        $zahlungsstatus = Shopware()->Models()->getRepository('Shopware\Models\Order\Status')->findOneBy(
            array('description' => $zahlungsstatusbeschreibung, 'group' => 'payment')
        );

        if (!$zahlungsstatus) {
            $this->View()->assign(
                array(
                    'success' => false,
                    'message' => 'Zahlungstatus nicht vorhanden. Installieren Sie das Plugin neu.'
                )
            );
        }

        $returnText = '';
        $returnAktenOk = 0;
        $returnAktenBereitsÜbernommen = 0;
        $returnAktenError = 0;

        foreach ($ids as $id) {
            /** @var \Shopware\Models\Order\Order $order */
            $order = Shopware()->Models()->getRepository('Shopware\Models\Order\Order')->find($id);

            if (!$order || !$order->getShipping() || !$order->getBilling()) {
                $returnAktenError += 1;
                continue;
            }

            $orderAttributes = $order->getAttribute();

            if ($orderAttributes->getAduInkassoAktenzeichen() !== null) {
                $returnAktenBereitsÜbernommen += 1;
                continue;
            }

            /** @var \Shopware\Models\Customer\Customer $customer */
            $customer = $order->getCustomer();

            $billing = $order->getBilling();

            $shipping = $order->getShipping();

            $q = Shopware()->Models()->getRepository('\Shopware\Models\Customer\Billing')->createQueryBuilder('b');
            $q->where('b.id = :id')->setParameter('id', $customer->getBilling()->getId());
            $q->select('b.number');
            $billingNumber = $q->getQuery()->getSingleScalarResult();

            $rep = $this->getBonitaetsdatensatzRep();
            $boni = $rep->getLastByCustomer($customer->getId());
            $freitext = '';

            if ($boni) {
                $freitext = 'Score von ' . $boni->getScore() . ' am ' . $boni->getAbfrageDatum()->format('d.m.Y H.i');
            }

            // Neue Akte anlegen
            $schuldner = array(
                'anrede' => ($billing->getCompany() != '') ? 'Firma' : $this->getAduInkassoSalutionFromShopwareSalutation($billing->getSalutation()),
                'firma' => $billing->getCompany(),
                'name' => $billing->getLastName(),
                'vorname' => $billing->getFirstName(),
                'strasse' => $this->getAduInkassoApi()->getStreetFromBilling($billing) . ' ' . $this->getAduInkassoApi()->getStreetNumberFromBilling($billing),
                'plz' => $billing->getZipCode(),
                'ort' => $billing->getCity(),
                'staat' => $billing->getCountry()->getIso(),
                'telefon' => $billing->getPhone(),
                'fax' => $billing->getFax(),
                'email' => $customer->getEmail(),
                'kommentar' => $freitext
            );

            $birthday = $customer->getBilling()->getBirthday();
            if ($birthday && $birthday instanceof \DateTime && $birthday->getTimestamp() > 0) {
                $schuldner['geburtstag'] = $birthday->format('c');
            }

            $forderungDetails = array();

            /** @var Shopware\Models\Order\Detail[] $details */
            $details = $order->getDetails();

            foreach ( $details as $detail ) {
                $forderungDetails[] = array(
                    'betrag' => (float)$detail->getPrice(),
                    'vertragsgegenstandsinfo1' => $detail->getQuantity() . ' x ' .$detail->getArticleName(),
                    'vertragsdatum' => $order->getOrderTime()->format('c')
                );
            }
            
            $sSQL = "SELECT c.date  AS 'date',c.docID  AS 'invoicenr' FROM s_order_documents AS c INNER JOIN s_core_documents AS cd ON c.type=cd.id WHERE c.orderID = ? AND c.type=1 LIMIT 0,1";
            $result = Shopware()->Db()->fetchAll($sSQL, array($order->getId()));
            
            // Lieferdatum
            $deliveryDate = (empty($result[0]['date'])) ? $order->getOrderTime()->format('c') : $result[0]['date'];
            
            // Rechnungsnummer mit Fallback
            $numberExport = (empty($result[0]['invoicenr'])) ? $billingNumber : $result[0]['invoicenr'];
            
            $forderung = array(
                'rechnungsnummer' => $numberExport,
                'belegnummer' => '',
                'forderungsArt_ID' => 21, // bis 1.1.1 9 = Kaufvertrag, ab 1.1.2 21 = Warenlieferung
                'datumHauptforderung' => $deliveryDate,
                'betrag' => $order->getInvoiceAmount(),
                'action' => 'insert',
                'anrede' => $this->getAduInkassoSalutionFromShopwareSalutation($shipping->getSalutation()),
                'firma' => $shipping->getCompany(),
                'name' => $shipping->getFirstName() . ' ' . $shipping->getLastName(),
                'strasse' => $this->getAduInkassoApi()->getStreetFromBilling($billing) . ' ' . $this->getAduInkassoApi()->getStreetNumberFromBilling($billing),
                'plz' => $shipping->getZipCode(),
                'ort' => $shipping->getCity(),
                'email' => $customer->getEmail(),
                'details' => $forderungDetails
            );

            $aktenzeichen = $billingNumber . '-' . $order->getNumber();

            $akte = array(
                'glaeubigerAktenzeichen' => $aktenzeichen,
                'freitext' => $freitext,
            );

            $data = array(
                'akte' => $akte,
                'schuldner' => $schuldner,
                'forderungen' => array($forderung)
            );

//            file_put_contents(__DIR__ . '/../tmp/bestellung_' . $aktenzeichen . '.txt', print_r($data, true), FILE_APPEND);


            $saveAkte = $this->getAduInkassoApi()->callClient('saveAkte', array(serialize($data)));
            $returnText .= '- ' . $saveAkte . '<br />';

            $returnAktenOk += 1;

            $orderAttributes->setAduInkassoAktenzeichen($aktenzeichen);

            // auf ADU-Inkasso setzen
            $order->setPaymentStatus($zahlungsstatus);

            Shopware()->Models()->flush();

        }

        $return = '';

        if ($returnAktenBereitsÜbernommen > 0) {
            $return .= $returnAktenBereitsÜbernommen . ' Akte(n) wurden bereits übernommen und können nicht erneut übernommen werden.<br /><br />';
        }

        if ($returnAktenError > 0) {
            $return .= 'Bei ' . $returnAktenError . ' Akte(n) gab es einen unbekannten Fehler bei der Übertragung.<br /><br />';
        }

        if ($returnAktenOk > 0) {
            $return .= $returnAktenOk . ' Akte(n) wurde(n) erfolgreich übernommen. Die Schnittstelle lieferte folgende Rückmeldungen: <br />' . $returnText;
        }


        $this->View()->assign(
            array(
                'success' => true,
                'message' => $return
            )
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     */
    public function saveZusatzkostenAction()
    {

        $data = array();

        $data['glaeubigerAktenzeichen'] = $this->Request()->getParam('glaeubigerAktenzeichen');
        $data['zusatzkosten'] = $this->getRequestArray(
            array(
                'zusatzkosten_ID',
                'belegnummer',
                'betrag',
                'datum'
            )
        );

        $data['zusatzkosten']['datum'] = date('c', strtotime($data['zusatzkosten']['datum']));
        $return = $this->getAduInkassoApi()->callClient('saveZusatzkosten', array(serialize($data)));

        if ($return === "1") {
            $return = 'Zusatzkosten wurden erfolgreich angelegt.';
        }


        $this->View()->assign(
            array(
                'success' => true,
                'message' => $return
            )
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     */
    public function getForderungenAction()
    {
        $cn = $this->Request()->getParam('cn');

        $forderungen = $this->getAduInkassoApi()->callClient('getForderungen', array($cn), true);

        if (isset($forderungen['forderungen'])) {
            $forderungen = $forderungen['forderungen'];
        }

        foreach ($forderungen as &$forderung) {
            $forderung['datumHauptforderung'] = new DateTime($forderung['datumHauptforderung']);
        }

        $this->view->assign(
            array(
                'success' => true,
                'data' => $forderungen,
                'total' => count($forderungen)
            )
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     */
    public function getGutschriftenAction()
    {
        $cn = $this->Request()->getParam('cn');

        $gutschriften = $this->getAduInkassoApi()->callClient('getGutschriften', array($cn), true);

        foreach ($gutschriften as &$gutschrift) {
            $gutschrift['datum'] = new DateTime($gutschrift['datum']);
        }

        $this->view->assign(
            array(
                'success' => true,
                'data' => $gutschriften,
                'total' => count($gutschriften)
            )
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     */
    public function getZusatzkostenAction()
    {
        $cn = $this->Request()->getParam('cn');

        $zusatzkosten = $this->getAduInkassoApi()->callClient('getZusatzkosten', array($cn), true);

        unset($zusatzkosten['belegnummer']);

        foreach ($zusatzkosten as &$zusatzkost) {
            $zusatzkost['datum'] = new DateTime($zusatzkost['datum']);
        }

        $this->view->assign(
            array(
                'success' => true,
                'data' => $zusatzkosten,
                'total' => count($zusatzkosten)
            )
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     */
    public function getVorgaengeAction()
    {
        $cn = $this->Request()->getParam('cn');

        $vorgaenge = $this->getAduInkassoApi()->callClient('getVorgaenge', array($cn), true);

        $vorgaenge = $vorgaenge['vorgaenge'][0]['items'];

        foreach ($vorgaenge as &$vorgang) {
            $vorgang['datum'] = new DateTime($vorgang['datum']);
        }

        $this->view->assign(
            array(
                'success' => true,
                'data' => $vorgaenge,
                'total' => count($vorgaenge)
            )
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     */
    public function getForderungsArtenAction()
    {
        $arten = $this->getForderungsArtenArray();
        $this->view->assign(
            array(
                'success' => true,
                'data' => $arten,
                'total' => count($arten)
            )
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     */
    public function deleteAkteAction()
    {
        $data = $this->getRequestArray(
            array(
                'glaeubigerAktenzeichen'
            )
        );

        $return = $this->getAduInkassoApi()->callClient('deleteAkte',array($data['glaeubigerAktenzeichen']));

        $this->View()->assign(
            array(
                'success' => true,
                'message' => $return
            )
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     */
    public function cancelGutschriftAction()
    {

        $data = $this->getRequestArray(
            array(
                'id',
                'glaeubigerAktenzeichen'
            )
        );
        $data['storno'] = 1;


        $return = $this->getAduInkassoApi()->callClient('cancelGutschrift',array(serialize($data)));

        $this->View()->assign(
            array(
                'success' => true,
                'message' => $return
            )
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     */
    public function cancelZusatzkostenAction()
    {
        $data = $this->getRequestArray(
            array(
                'id',
                'glaeubigerAktenzeichen'
            )
        );
        $data['storno'] = 1;

        $return = $this->getAduInkassoApi()->callClient('cancelZusatzkosten',array(serialize($data)));

        $this->View()->assign(
            array(
                'success' => true,
                'message' => $return
            )
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     */
    public function getRechtsformenAction()
    {
        $arten = $this->getRechtsformenArray();
        $this->view->assign(
            array(
                'success' => true,
                'data' => $arten,
                'total' => count($arten)
            )
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     */
    public function getEinstellungsartenAction()
    {
        $arten = $this->getEinstellungsartenArray();
        $this->view->assign(
            array(
                'success' => true,
                'data' => $arten,
                'total' => count($arten)
            )
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     * @return array
     */
    private function getForderungsArtenArray()
    {
        $fa = array(
            array('2', 'H01', 'Anzeigenkosten'),
            array('3', 'H02', 'Ärztl./Zahnärztl.Leistun'),
            array('4', 'H05', 'Dienstleistung'),
            array('5', 'H06', 'Frachtkosten'),
            array('6', 'H07', 'Geschäftsbesorgung'),
            array('7', 'H08', 'Handwerkerleistung'),
            array('8', 'H09', 'Heimunterbringung'),
            array('9', 'H11', 'Kaufvertrag'),
            array('10', 'H13', 'Kranken/Pflege/Arzenei'),
            array('11', 'H14', 'Lagerkosten'),
            array('12', 'H15', 'Leasing/Mietkauf'),
            array('13', 'H16', 'Lehrgangs-/Unterrichtsk.'),
            array('14', 'H20', 'Mietnebenkosten'),
            array('15', 'H22', 'Mitgliedsbeitrag'),
            array('16', 'H24', 'RA-/Rechtsbeist.honorar'),
            array('17', 'H26', 'Reparaturleistung'),
            array('18', 'H34', 'Versand-/Speditionskost.'),
            array('19', 'H40', 'Vermittlungs/Maklerprov.'),
            array('20', 'H41', 'Vers.prämie/-beitrag'),
            array('21', 'H43', 'Warenlieferung'),
            array('22', 'H44', 'Werkvertrag'),
            array('23', 'H45', 'Zeitschriftenbestellung'),
            array('24', 'H47', 'Ticketbestellung'),
            array('25', 'H51', 'Dienstleistung Internet ')
        );

        $return = array();
        foreach ($fa as $f) {
            $return[] = array(
                'forderungsArt_ID' => $f[0],
                'schluessel' => $f[1],
                'bezeichnung' => $f[2]
            );
        }

        return $return;
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     * @return array
     */
    private function getRechtsformenArray()
    {
        $rf = array(
            array('0', 'keine Angabe'),
            array('1', 'AG'),
            array('2', 'BGB-Gesellschaft'),
            array('3', 'e. G.'),
            array('4', 'e. V.'),
            array('5', 'GbR'),
            array('6', 'GmbH'),
            array('7', 'Inc.'),
            array('8', 'KG'),
            array('9', 'Ltd.'),
            array('10', 'OHG')
        );

        $return = array();
        foreach ($rf as $r) {
            $return[] = array(
                'ID' => $r[0],
                'bezeichnung' => $r[1]
            );
        }

        return $return;
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     * @return array
     */
    private function getEinstellungsartenArray()
    {
        $za = array(
            array('1', 'Insolvenz', 'NGP02'),
            array('2', 'Sonstige/Bemerkung', 'NGP05'),
            array('3', 'Kunde wünscht Abschluss', 'NGP01'),
//            array('4', 'Sonstige/Bemerkung', 'NGTI8'),
            array('9', 'Verstorben', 'NGP03'),
//            array('14', 'Kunde wünscht Abschluss', 'NGTI2'),
//            array('15', 'Neue RG', 'NGTI3'),
//            array('19', 'Storno MG', 'NGTI4'),
            array('20', 'Zahlung Gläubiger / einst.', 'NGTI6'),
//            array('21', 'Stundung', 'NGTI7'),
//            array('22', 'Vergleich', 'Mahngebühr', 'NGTI9')
        );
        $return = array();
        foreach ($za as $z) {
            $return[] = array(
                'einstellung_ID' => $z[0],
                'bezeichnung' => $z[1],
                'kuerzel' => $z[2]
            );
        }

        return $return;
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     * @return array
     */
    private function getGutschriftenartenArray()
    {
        return array(
            array(
                'gutschrift_ID' => 1,
                'name' => 'Gutschrift des Gläubigers',
                'kuerzel' => 'Z006'
            ),
            array(
                'gutschrift_ID' => 2,
                'name' => 'Zahlung des Schuldners',
                'kuerzel' => 'Z004'
            )
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     * @return array
     */
    private function getZusatzkostenartenArray()
    {
        return array(
            array(
                'zusatzkosten_ID' => 1,
                'name' => 'Interne Mahnkosten',
                'kuerzel' => 'K001'
            ),
            array(
                'zusatzkosten_ID' => 2,
                'name' => 'Rücklastschriftgebühr',
                'kuerzel' => 'K005'
            ),
            array(
                'zusatzkosten_ID' => 3,
                'name' => 'Auslagen des Gläubigers',
                'kuerzel' => 'K025'
            ),
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     * @return array
     */
    public function getStornoartenArray()
    {
        return array(
            array(
                'storno_art_ID' => 1,
                'grund' => 'Storno',
                'beschreibung' => 'Storno ohne besonderen Grund',
                'kuerzel' => 'NGS03'
            )
        );
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     * @param int $seite
     * @param int $aktenProSeite
     * @param string $sortField
     * @param string $sortDir
     * @param string $search
     * @return mixed
     */
    private function getAkten($seite = 1, $aktenProSeite = 10, $sortField = 'name', $sortDir = 'asc', $search = '')
    {
        $data = array(
            '',
            $seite,
            $aktenProSeite,
            $sortField,
            $sortDir,
            $search
        );

        return $this->getAduInkassoApi()->callClient('getAkten',$data,true);
    }


}
