<?php

namespace Shopware\CustomModels\AduInkasso;

use Shopware\Components\Model\ModelEntity,
    Doctrine\ORM\Mapping AS ORM,
    Symfony\Component\Validator\Constraints as Assert;

/**
 * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
 * Shopware\CustomModels\SwagFavorites\Favorite
 *
 * @ORM\Table(name="adu_inkasso_bonitaetdatensatz")
 * @ORM\Entity(repositoryClass="Repository")
 */
class Bonitaetdatensatz extends ModelEntity
{
    /**
     * @var integer $id
     *
     * @ORM\Column(name="id", type="integer", precision=0, scale=0, nullable=false, unique=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
    * @var integer $customerId
    * @ORM\Column(name="customer_id", type="integer", nullable=false)
    */
    private $customerId;

    /**
     * @var float
     * @ORM\Column(name="score",type="float");
     */
    private $score;

    /**
     * @var \DateTime $created
     *
     * @ORM\Column(name="abfrage_datum", type="datetime", precision=0, scale=0, nullable=false, unique=false)
     */
    private $abfrage_datum;

    /** @var string
     * @ORM\Column(type="text")
     */
    private $zusatzinformationen;

    /**
     * @var bool
     * @ORM\Column(type="boolean")
     */
    private $is_company = false;

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     * @param $customerId
     * @param $score
     * @param \DateTime $abfrage_datum
     * @param string $zusatzinformation
     */
    public function __construct($customerId,$score,\DateTime$abfrage_datum,$zusatzinformation='') {
        $this->customerId = $customerId;
        $this->score = str_replace(',','.',$score);
        $this->abfrage_datum = $abfrage_datum;
        $this->zusatzinformationen = $zusatzinformation;
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     * @return mixed
     */
    public function getCustomerId()
    {
        return $this->customerId;
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     * @return string
     */
    public function getScore()
    {
        return (float)str_replace(',','.',$this->score);
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     * @return \DateTime
     */
    public function getAbfrageDatum()
    {
        return $this->abfrage_datum;
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     * @return string
     */
    public function getZusatzinformationen()
    {
        return $this->zusatzinformationen;
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     * @return bool
     */
    public function isValid() {
        if ($this->getScore() > 0 ) {
            Shopware()->Debuglogger()->addNotice('ADU', 'isValid true');
            return true;
        }
        Shopware()->Debuglogger()->addNotice('ADU', 'isValid false');
        return false;
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     * @param boolean $is_company
     */
    public function setIsCompany($is_company)
    {
        $this->is_company = $is_company;
        
    }

    /**
     * Die ShopwareAG wünscht überall Kommentare, dies ist ein Kommentar.
     * @return boolean
     */
    public function isCompany()
    {
        return $this->is_company;
    }

}