//{block name="backend/AduInkasso/model/mein_model"}
Ext.define('Shopware.apps.AduInkasso.model.Akten', {

    extend: 'Ext.data.Model',

    fields: [
        //{block name="backend/mein_plugin/model/mein_model/fields"}{/block}
        { name : "aktenzeichen", type : "string" },

        { name : "gutschrift_stornierbar", type : "boolean", defaultValue: false },
        { name : "zusatzkosten_stornierbar", type : "boolean", defaultValue: false },
        { name : "akte_einstellbar", type : "boolean", defaultValue: false },
        { name : "akte_bearbeitbar", type : "boolean", defaultValue: false },
        { name : "akte_loeschbar", type : "boolean", defaultValue: false },

        { name : "lv_datum"},
        { name : "lv_beschreibung", type : "string" },
        { name : "lz_datum"},
        { name : "einstellung_grund", type : "string" },
        { name : "einstellung_datum"},

        { name : "produkt", type : "string" },
        { name : "unterAktenzeichen", type : "string" },
        { name : "rechnungsnummer", type : "string" },
        { name : "forderungsArt_ID", type : "string" },
        { name : "freitext", type : "string" },
        { name : "belegnummer", type : "string" },
        { name : "betrag", type : "float" },
        { name : "betragOffen", type : "float" },
        { name : "betragUebernommen", type : "float" },
        { name : "glaeubiger", type : "string" },
        { name : "glaeubigerAktenzeichen", type : "string" },
        { name : "datumHauptforderung" },
        { name : "uebernahmeDatum" },
        { name : "abschlussDatum" },
        { name : "stadium", type : "string" },
        { name : "aktionskennzeichen", type : "string" },
        { name : "letzteAenderung" },
        { name : "exported", type : "string" },
        { name : "status", type : "string" },
        { name : "exportDatum", type : "string" },
        { name : "anrede", type : "string" },
        { name : "firma", type : "string" },
        { name : "rechtsform_ID", type : "string" },
        { name : "name", type : "string" },
        { name : "vorname", type : "string" },
        { name : "zuHaenden", type : "string" },
        { name : "strasse", type : "string" },
        { name : "kommentar", type : "string" },
        { name : "plz", type : "string" },
        { name : "ort", type : "string" },
        { name : "geburtstag" },
        { name : "telefon", type : "string" },
        { name : "fax", type : "string" },
        { name : "email", type : "string" },
        { name : "arbeitgeber", type : "string" },
        { name : "ehepartner", type : "string" },
        { name : "vertreter", type : "string" },
        { name : "evDatum" },
        { name : "haftbefehlDatum" },
        { name : "insolvenzDatum" },
        { name : "staat", type : "string" },
        { name : "bank", type : "string" },
        { name : "blz", type : "string" },
        { name : "iban", type : "string" },
        { name : "bic", type : "string" },
        { name : "kto", type : "string" },
        { name : "inhaber", type : "string" },
        { name : "ip", type : "string" },
        { name : "insolvenzAZ", type : "string" }
    ],

    proxy: {
        type: 'ajax',

        api: {
            create: '{url action="saveAkte"}',
            update: '{url action="saveAkte"}',
            delete: '{url action="deleteAkte"}'
        },

        reader: {
            type: 'json',
            root: 'data'
        }
    },


    associations: [
        {
            type: 'hasMany',
            model: 'Shopware.apps.AduInkasso.model.Forderung',
            name: 'getForderungen',
            associationKey: 'forderungen'
        }
    ]

});
//{/block}
