//{block name="backend/AduInkasso/view/grid"}
Ext.define('Shopware.apps.AduInkasso.view.DetailGridForderungen', {

    extend: 'Ext.grid.Panel',

    alias: 'widget.aduinkasso-view-detailgridforderungen',

    store: { xtype: 'store', model: 'Shopware.apps.AduInkasso.model.Forderung' },

    features: [{
            ftype: 'summary'
        }],

    initComponent: function () {
        var me = this;

        me.columns = me.getColumns();

//        me.tbar = me.getToolbar();

//        me.bbar = me.getPagingbar();

        me.addEvents('deleteForderung', 'addForderung');

        me.callParent(arguments);
    },


    getColumns: function () {
        var me = this;

        return [
            { header: 'Stadium', dataIndex: 'stadium', flex: 1},
            { header: 'Forderungsart', dataIndex: 'forderungsArt_ID', flex: 1,
                renderer : function(value) {
                    return me.forderungsarten.findRecord('forderungsArt_ID',value).get('bezeichnung');
                },
                summaryRenderer : function() {
                    return 'Zwischensumme:';
                }
            },
            { header: 'Betrag', dataIndex: 'betrag', flex: 1,
                summaryType: 'sum'
            },
            { header: 'Rechnungsnummer', dataIndex: 'rechnungsnummer', flex: 1},
            { header: 'Belegnummer', dataIndex: 'belegnummer', flex: 1}
        ];
    },

    getActionColumn: function () {
        var me = this;

        return [
            {
                iconCls: 'sprite-mail--pencil',
                tooltip: 'Editieren',
                handler: function (view, rowIndex, colIndex, item, opts, record) {
                    me.fireEvent('deleteForderung', record);
                }
            }
        ];
    },

    getToolbar: function () {
        var me = this;

        me.toolbar = Ext.create('Ext.toolbar.Toolbar', {
            ui: 'shopware-ui',
            items: [
                '->',
                {
                    xtype: 'textfield',
                    name: 'searchfield',
                    emptyText: 'Suche',
                    cls: 'searchfield',
                    checkChangeBuffer: 700,
                    listeners: {
                        change: function (field, value) {
                            me.fireEvent('textChanged', field);
                        }
                    }
                }
            ]
        });

        return me.toolbar;

    },

    getPagingbar: function () {
        var me = this;

        return [
            {
                xtype: 'pagingtoolbar',
                displayInfo: true,
                store : me.store
            }
        ];
    }
});
//{/block}