//{block name="backend/AduInkasso/view/grid"}
Ext.define('Shopware.apps.AduInkasso.view.DetailGridZusatzkosten', {

    extend: 'Ext.grid.Panel',

    alias: 'widget.aduinkasso-view-detailgridzusatzkosten',

    store: { xtype: 'store', model: 'Shopware.apps.AduInkasso.model.Zusatzkosten' },

    features: [
        {
            ftype: 'summary'
        }
    ],


    initComponent: function () {
        var me = this;

        me.dockedItems = [
                    {
                        xtype: 'toolbar',
                        dock: 'top',
                        ui: 'shopware-ui',
                        items: [
                            {
                                xtype: 'button',
                                iconCls: 'sprite-plus-circle',
                                text: 'Zusatzkosten hinzufügen',
                                handler: function (view) {
                                    me.fireEvent('addZusatzkosten', view);
                                }
                            }
                        ]
                    }
                ];

                me.columns = me.getColumns();

                me.addEvents('deleteZusatzkosten', 'addZusatzkosten');


        me.callParent(arguments);
    },

    getColumns: function () {
        var me = this;

        return [
            { header: 'Rechnungsnummer', dataIndex: 'belegnummer', flex: 1 },
            { header: 'Datum', dataIndex: 'datum', flex: 1, renderer: Ext.util.Format.dateRenderer('d.m.Y') },
            { header: 'Art', dataIndex: 'zusatzkosten_ID',
                renderer: function (value) {
                    if (value == 1) return 'Interne Mahnkosten';
                    if (value == 2) return 'Rücklastschriftgebühr';
                    return 'Auslagen des Gläubigers';
                },
                summaryRenderer: function () {
                    return 'Zwischensumme:';
                }
            },
            { header: 'Betrag', dataIndex: 'betrag', flex: 2,
                summaryType: 'sum'
            }
            ,
            {
                header: 'Optionen',
                xtype: 'actioncolumn',
                width: 120,
                items: me.getActionColumn()
            }
        ];
    },

    getActionColumn: function () {
            var me = this;

            return [
                {
                    iconCls: 'sprite-minus-circle-frame',
                    tooltip: 'Zusatzkosten löschen',
                    handler: function (view, rowIndex, colIndex, item, opts, record) {
                        me.fireEvent('deleteZusatzkosten', view, record);
                    }
                }
            ];
        },

    getToolbar: function () {
        var me = this;

        me.toolbar = Ext.create('Ext.toolbar.Toolbar', {
            ui: 'shopware-ui',
            items: [
                '->',
                {
                    xtype: 'textfield',
                    name: 'searchfield',
                    emptyText: 'Suche',
                    cls: 'searchfield',
                    checkChangeBuffer: 700,
                    listeners: {
                        change: function (field, value) {
                            me.fireEvent('textChanged', field);
                        }
                    }
                }
            ]
        });

        return me.toolbar;

    },

    getPagingbar: function () {
        var me = this;

        return [
            {
                xtype: 'pagingtoolbar',
                displayInfo: true,
                store: me.store
            }
        ];
    }
});
//{/block}