//{block name="backend/AduInkasso/view/DetailWindowGutschriften"}
Ext.define('Shopware.apps.AduInkasso.view.DetailWindowZusatzkosten', {
    extend: 'Enlight.app.Window',
    alias: 'widget.aduinkasso-view-detailwindowzusatzkosten',
    cls: 'createWindow',
    modal: true,

    layout: 'border',
    autoShow: true,
    title: 'Zusatzkosten hinzufügen',
    border: 0,
    width: 600,
    height: 270,
    stateful: true,
    stateId: 'shopware-premium-detail',
    footerButton: false,

    glaeubigerAktenzeichen : null,
    latestForderungDate : new Date(),

    initComponent: function () {
        var me = this;

        me.premiumForm = me.createFormPanel();
        me.dockedItems = [
            {
                xtype: 'toolbar',
                ui: 'shopware-ui',
                dock: 'bottom',
                cls: 'shopware-toolbar',
                items: me.createButtons()
            }
        ];

        me.items = [me.premiumForm];
        me.callParent(arguments);
    },

    createFormPanel: function () {
        var me = this;
        var premiumForm = Ext.create('Ext.form.Panel', {
            collapsible: false,
            split: false,
            region: 'center',
            defaults: {
                labelStyle: 'font-weight: 700; text-align: right;',
                labelWidth: 130,
                anchor: '100%'
            },
            bodyPadding: 10,
            items: [
                {
                    xtype: 'textfield',
                    name: 'belegnummer',
                    fieldLabel: 'Rechnungsnummer',
                    allowBlank: true
                },
                {
                    xtype: 'aduinkasso-datefield',
                    name : 'datum',
                    fieldLabel: 'Datum',
                    allowBlank: false,
                    minValue: me.latestForderungDate
                },
                {
                    xtype: 'combobox',
                    name: 'zusatzkosten_ID',
                    fieldLabel: 'Art',
                    store: {
                        xtype: 'store',
                        fields: ['id', 'name'],
                        data: [
                            { "id": "1", "name": "Interne Mahnkosten"},
                            { "id": "2", "name": "Rücklastschriftgebühr"},
                            { "id": "3", "name": "Auslagen des Gläubigers"}
                        ]
                    },
                    valueField: 'id',
                    displayField: 'name',
                    emptyText: 'Bitte auswählen',
                    allowBlank: false
                },
                {
                    fieldLabel: 'Betrag',
                    xtype: 'aduinkasso-numberfield',
                    name: 'betrag',
                    allowBlank: false
                }

            ]
        });

        if (me.record) {
            premiumForm.loadRecord(me.record);
        }

        return premiumForm;
    },

    createButtons: function () {
        var me = this;
        var buttons = ['->',
            {
                text: 'Abbrechen',
                cls: 'secondary',
                scope: me,
                handler: me.destroy
            },
            {
                text: 'Speichern',
                action: 'saveZusatzkosten',
                cls: 'primary'
            }
        ];

        return buttons;
    }
});
//{/block}