Ext.define('Shopware.apps.AduInkasso.view.WindowAkteEinstellen', {

    extend: 'Ext.Window',
    alias: 'widget.aduinkasso-view-window-akte-einstellen',
    cls: 'createWindow',
    modal: true,

    layout: 'border',
    autoShow: true,
    title: 'Akte einstellen',
    border: 0,
    width: 450,
    height: 270,
    stateful: true,
//    stateId: 'shopware-premium-detail',
    footerButton: false,

    initComponent: function () {
        var me = this;

        me.premiumForm = me.createFormPanel();
        me.dockedItems = [
            {
                xtype: 'toolbar',
                ui: 'shopware-ui',
                dock: 'bottom',
                cls: 'shopware-toolbar',
                items: me.createButtons()
            }
        ];

        me.items = [me.premiumForm];
        me.callParent(arguments);
    },

    createFormPanel: function () {
        var me = this;

        var premiumForm = Ext.create('Ext.form.Panel', {
            collapsible: false,
            split: false,
            region: 'center',
            defaults: {
                labelStyle: 'font-weight: 700; text-align: right;',
                labelWidth: 130,
                anchor: '100%'
            },
            bodyPadding: 10,
            items: [
                {
                    xtype: 'combobox',
                    fieldLabel: 'Aktion',
                    displayField: 'bezeichnung',
                    valueField: 'einstellung_ID',
                    allowBlank: false,
                    name: 'einstellung_ID',
                    store: {
                        xtype: 'jsonstore',
                        proxy: {
                            type: 'ajax',
                            url: '{url action=getEinstellungsarten}',
                            reader: {
                                type: 'json',
                                root: 'data',
                                totalProperty: 'total'
                            }
                        },
                        fields: ['einstellung_ID', 'bezeichnung'],
                        autoLoad: true
                    }
                },
                {
                    showOn: 2,
                    xtype: 'textfield',
                    fieldLabel: 'Bemerkung',
                    name: 'bemerkung',
                    allowBlank: false,
                    disabled: true
                },
                {
                    showOn: 1,
                    xtype: 'textfield',
                    fieldLabel: 'Insolvenz-AZ',
                    name: 'insolvenaz',
                    allowBlank: false,
                    disabled: true
                },
                {
                    showOn: 9,
                    xtype: 'aduinkasso-datefield',
                    fieldLabel: 'Sterbedatum',
                    name : 'sterbedatum',
                    allowBlank: false,
                    disabled: true
                }

            ]
        });

        if (me.record) {
            premiumForm.loadRecord(me.record);
        }

        return premiumForm;
    },

    createButtons: function () {
        var me = this;
        return ['->',
            {
                text: 'Abbrechen',
                cls: 'secondary',
                scope: me,
                handler: me.destroy
            },
            {
                text: 'Akte einstellen',
                action: 'akteEinstellen',
                cls: 'primary'
            }
        ];
    }
});
