//{block name="backend/customer/view/detail/additional" append}
Ext.define('Shopware.apps.Customer.view.detail.adu_inkasso.Additional', {
    override: 'Shopware.apps.Customer.view.detail.Additional',

    initComponent: function () {
        var me = this;
        me.callParent(arguments);
        me.items.insert(1, me.createAduInkassoInfoView());
    },

    createAduInkassoInfoView: function () {
        var me = this;

        me.AduInfoView = Ext.create('Ext.container.Container', {
            cls: Ext.baseCSSPrefix + 'outer-customer-info-pnl',
            emptyText: me.snippets.emptyText,
            autoScroll: true,
            tpl: me.createAduInkassoInfoPanelTemplate(),
            data: { }
        });

        return me.AduInfoView;
    },

    createAduInkassoInfoPanelTemplate: function () {
        var me = this;

        return new Ext.XTemplate(
            '{literal}<tpl for=".">',
            '<div class="media-info-pnl">',
            '<div class="base-info">',
            '<p>',
            '<strong>ADU-Inkasso Score</strong>',
            '{[this.Score(values.score,values.datum)]}',
            '</p>',
            '</div>',
            '</div>',
            '</tpl>{/literal}',
            {
                Score: function (score, datum) {
                    return AduInkasso.Helper.getScoreLightRendered(score, datum);
                }
            }
        );
    }
});
//{/block}