//{block name="backend/index/model/orders" append}

Ext.ns('AduInkasso.Helper');

AduInkasso.Helper = {
    getScoreLightRendered: function (score, date, meta) {
        var setMeta = '';
        var pre = "<span style=\"margin: 3px 3px 0 0;border-radius:50%; background-color:";
        var post = "; display: block; width: 10px; height: 10px; float: left;\">&nbsp;</span> ";

        var grey = pre + '#808080' + post;
        var green = pre + '#008000' + post;
        var red = pre + '#ff0000' + post;
        var orange = pre + '#ffa500' + post;
        if (!score || score == 0) {
            if (meta) {
                setMeta = 'Keine Einschätzung möglich. Hierbei handelt es sich um stichtagsbezogene Daten.';
                meta.tdAttr = 'data-qtip="' + Ext.String.htmlEncode(setMeta) + '"';
            }
            return grey + '<i>unbekannt</i>';
        }
        var ret = '';
        if (score <= {$adu_inkasso_score_green|default:2.5}) {
            ret += green;
        } else if (score <= {$adu_inkasso_score_yellow|default:2.9}) {
            ret += orange;
        } else {
            ret += red;
        }

        if (score <= 2.5) {
            setMeta = 'Statistisches Ausfallrisiko gering bis durchschnittlich.';
        } else if (score <= 2.9) {
            setMeta = 'Statistisches Ausfallrisiko überdurchschnittlich.';
        } else {
            setMeta = 'Es liegen negative Zahlungserfahrungen vor.';
        }

        if (meta) {
            setMeta += ' Hierbei handelt es sich um stichtagsbezogene Daten.';
            meta.tdAttr = 'data-qtip="' + Ext.String.htmlEncode(setMeta) + '"';
        }
        return ret + score + ' (' + Ext.util.Format.dateRenderer('d.m.Y')(date) + ')';
    },
    formError: function (errorMessage) {
        if (!errorMessage) {
            errorMessage = 'Bitte füllen Sie alle Felder korrekt aus.';
        }
        Ext.Msg.show({
            title: 'Fehler beim Formular',
            msg: errorMessage,
            buttons: Ext.Msg.OK
        });
    },
    statusRenderer: function (value, meta, record) {
        var icon = '';
        var hover = '';
        switch (value) {
            case 'unbekannt':
                icon = 'grey';
                hover = 'Die Akte ist neu und noch nicht von ADU-Inkasso exportiert.';
                break;
            case 'bearbeitung':
                icon = 'yellow';
                hover = 'Die Akte befindet sich in der Bearbeitung bei ADU-Inkasso. Änderungen sind derzeit nicht möglich.';
                break;
            case 'ok':
                icon = 'green';
                hover = 'Akte ist aktiv.';
                break;
            case 'eingestellt':
                icon = 'red';
                hover = 'Akte ist eingestellt.';
                if (record) {
                    hover += ' Diese Akte wurde am ' + Ext.util.Format.dateRenderer('d.m.Y')(record.get('einstellung_datum')) + ' eingestellt. ' + record.get('einstellung_grund');
                }
                break;
        }
        if (meta) {
            meta.tdAttr = 'data-qtip="' + Ext.String.htmlEncode(hover) + '"';
        }
        return '<span class="adu-inkasso-stadium-icon-' + icon + '">&nbsp;</span>';
    },
    vorgangRenderer: function (record, meta) {
        var vorgangsdatum = record.get('lv_datum'),
            zahlungsdatum = record.get('lz_datum'),
            vorgangsbeschreibung = record.get('lv_beschreibung');
        if (!vorgangsdatum || vorgangsdatum == '') {
            return '';
        }
        var euro = '';
        var hover = 'Vorgang vom ' + Ext.util.Format.dateRenderer('d.m.Y')(vorgangsdatum) + '.';
        if (zahlungsdatum && zahlungsdatum != '') {
            euro = ' <span class="adu-inkasso-vorgaenge-euro">&euro;</span>';
            hover += ' Zahlung vom ' + Ext.util.Format.dateRenderer('d.m.Y')(zahlungsdatum) + '.';
        }
        if (meta) {
            meta.tdAttr = 'data-qtip="' + Ext.String.htmlEncode(hover) + '"';
        }
        return vorgangsbeschreibung + euro;
    },
    alert: function (title, msg) {
        if ( !title || title == '' ) {
            title = 'Hinweis';
        }
        Ext.Msg.show({
            title: title,
            msg: msg,
            buttons: Ext.Msg.OK
        });
    }
};

Ext.define('AduInkasso.Numberfield', {
    extend: 'Ext.form.field.Number',
    alias: 'widget.aduinkasso-numberfield',
    minValue: 1,
    step: 1,
    decimalSeparator: ',',
    decimalPrecision: 2,
    submitLocaleSeparator: false
});

Ext.define('AduInkasso.Datefield', {
    extend: 'Ext.form.field.Date',
    alias: 'widget.aduinkasso-datefield',
    maxValue: new Date()
});

//{/block}